#!/usr/bin/env python
# Copyright (c) 2011 Praveen Kumar <kumarpraveen.nitdgp@gmail.com>
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use,
# copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following
# conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

import os
import sys
import MySQLdb
import shutil

def user_detail(username):
    #connect to MYSQL database
    db = MySQLdb.connect("localhost","root","root","lsync" )
    
    # prepare a cursor object using cursor() method
    cursor = db.cursor()
    
    # Prepare SQL query to INSERT a record into the database.
    sql = "select * from user_detail where username = '%s'" % (username)
    
    try:
        # Execute the SQL command
        cursor.execute(sql)
        
        # Fetch all the rows in a list of lists.
        row = cursor.fetchone()
        user_name = row[0]
        password = row[1]
        path = row[2]
        return password
    
    except:
        print "Error: unable to fetch data"
        return "^&*"
    
    # disconnect from server
    db.close()

def user_add(username,password):
    db = MySQLdb.connect("localhost","root","root","lsync" )
    
    # prepare a cursor object using cursor() method
    cursor = db.cursor()
    
    
    path = "/var/www/html/" + username + "/"
    if not os.path.exists(path):
        try:
            os.mkdir(path)
        except os.error:
            print "Error with creating directory"
            sys.exit(1)
        
    # Prepare SQL query to INSERT a record into the database.
    sql = "insert into user_detail values('%s','%s','%s')" % (username, password, path) 
    
    try:
        # Execute the SQL command
        cursor.execute(sql)
        
        # Commit your changes in the database
        db.commit()
    
    except:
        print "Error: unable to fetch data"
        # Rollback in case there is any error
        db.rollback()
    
    # disconnect from server
    db.close()
    

def data_transfer(path,filename,filesize,clientsock):
    print "data_transfer function"
    try:
        f = open(path+filename,"w")
    except IOError,message:
        print >> sys.stderr,"error with file creation"
    data_receive=0
    chunk_size=4096
    while data_receive < int(filesize):
        data = clientsock.recv(4096)
        f.write(data)
        data_receive += len(data)
        #print "Bytes received %d",data_receive
    return 1

def deleted_files(path,filename):
    print "deleted files function"
    path1 = path + "Deleted_files/"
    if not os.path.exists(path1):
        try:
            os.mkdir(path1)
        except os.error:
            print "Error with creating directory"
            sys.exit(1)
    shutil.move(path+filename, path1)
        