#!/usr/bin/env python
# Copyright (c) 2011 Praveen Kumar <kumarpraveen.nitdgp@gmail.com>
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use,
# copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following
# conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

#create a basic client 
import socket
import sys
import os
import time
from client_function import *

#creating a socket
try:
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
except socket.error,e:
    print "Strange error creating socket %s " % e
    sys.exit(1)


#read all details from configuration file
host,port,username,password,path = conf_read()
port = int(port)
userinfo = username + '\t' + password


#connect to the server with specific port
try:
    s.connect((host,port))
except socket.gaierror,e:
    print "Address related error connecting server %s " %e
    sys.exit(1)
except socket.error,e:
    print "Connection error %s " %e
    sys.exit(1)
    
#blocking and non-blocking sockets
#option 0 for non-blocking mode and 1 for blocking mode
s.setblocking(1)

#sending user-Info to server
userinfo_send = s.send(userinfo)
if userinfo_send:
    print "User Info sent"
else:
    print "Problem with sending User Info"
buf = s.recv(20)
if "ok" in buf:
    print "server got Info"
elif "add" in buf:
    print "username and password is successfully added on server"
    sys.exit(1)
elif "fail" in buf:
    print "username and password did not match check configuration file and run demon again"
    sys.exit(1)
else:
    print "server did not get info"
    sys.exit(1)

#creating deamon
while True:
    #getting the file list
    files_list = enumratefiles(path)
    delete_list = deleted_files(path)
    #sending files Info
    while files_list:
        files_detail = files_list.pop()
        files_detail_string = str(files_detail[0])+":"+str(files_detail[2])
        send_data = s.send(files_detail_string)
        if not send_data:
            print "problem with sending details"
            sys.exit(1)
        buf = s.recv(20)
        if "ok" in buf:
            check = data_transfer(s,files_detail[1],files_detail[2])
            if not check:
                print "error during sending"
                sys.exit(1)
        else:
            print "file detail not sent"
        time.sleep(.3)
    if delete_list:
        while delete_list:
            files_detail = delete_list.pop()
            files_detail_string = str(files_detail)+":D"
            send_data = s.send(files_detail_string)
            time.sleep(.3)
    lists_files(path)
    time.sleep(10)